/// <reference types="bn.js" />
import { Instruction } from "@orca-so/common-sdk";
import { PublicKey } from "@solana/web3.js";
import { Program, BN } from "@project-serum/anchor";
import { Escrow } from "../artifacts/escrow";
export type InitializeConfigParams = {
    configId: string;
    escrowConfigPubkey: PublicKey;
    tradeConfigAuthority: PublicKey;
    amlPolicyAuthority: PublicKey;
    treasuryPubkey: PublicKey;
    quota: BN[];
    deployer: PublicKey;
    bondSize: BN;
    arbitratorCommission: BN;
    treasuryShare: BN;
    paymentDuration: BN;
};
export declare function initializeConfig(program: Program<Escrow>, params: InitializeConfigParams): Promise<Instruction>;
