"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PDA = void 0;
const anchor = __importStar(require("@project-serum/anchor"));
const CONFIG_SEED = "config";
const TRADE_ORDER_SEED = "order";
const TOKEN_VAULT_SEED = "token_vault";
const NATIVE_VAULT_SEED = "native_vault";
const ARBITRATOR_CERT_SEED = "arbitrator_cert";
const KYC_CERT_SEED = "kyc_cert";
const TOKEN_INFO_SEED = "token_info";
class PDA {
    constructor(programId, configId) {
        this.getConfigPDA = () => {
            const [pda, bump] = anchor.web3.PublicKey.findProgramAddressSync([anchor.utils.bytes.utf8.encode(CONFIG_SEED), anchor.utils.bytes.utf8.encode(this.configId)], this.programId);
            return {
                key: pda,
                bump: bump,
            };
        };
        this.getTradeOrderPDA = (orderID) => {
            const configPDA = this.getConfigPDA();
            const [pda, bump] = anchor.web3.PublicKey.findProgramAddressSync([
                anchor.utils.bytes.utf8.encode(TRADE_ORDER_SEED),
                configPDA.key.toBuffer(),
                orderID.toArrayLike(Buffer, "le", 8),
            ], this.programId);
            return {
                key: pda,
                bump: bump,
            };
        };
        this.getTokenVaultPDA = (orderID) => {
            const configPDA = this.getConfigPDA();
            const [pda, bump] = anchor.web3.PublicKey.findProgramAddressSync([
                anchor.utils.bytes.utf8.encode(TOKEN_VAULT_SEED),
                configPDA.key.toBuffer(),
                orderID.toArrayLike(Buffer, "le", 8),
            ], this.programId);
            return {
                key: pda,
                bump: bump,
            };
        };
        this.getNativeVaultPDA = (orderID) => {
            const configPDA = this.getConfigPDA();
            const [pda, bump] = anchor.web3.PublicKey.findProgramAddressSync([
                anchor.utils.bytes.utf8.encode(NATIVE_VAULT_SEED),
                configPDA.key.toBuffer(),
                orderID.toArrayLike(Buffer, "le", 8),
            ], this.programId);
            return {
                key: pda,
                bump: bump,
            };
        };
        this.getArbitratorCertPDA = (arbitratorAuthority) => {
            const configPDA = this.getConfigPDA();
            const [pda, bump] = anchor.web3.PublicKey.findProgramAddressSync([
                anchor.utils.bytes.utf8.encode(ARBITRATOR_CERT_SEED),
                configPDA.key.toBuffer(),
                arbitratorAuthority.toBuffer(),
            ], this.programId);
            return {
                key: pda,
                bump: bump,
            };
        };
        this.getKycCertPDA = (user) => {
            const configPDA = this.getConfigPDA();
            const [pda, bump] = anchor.web3.PublicKey.findProgramAddressSync([anchor.utils.bytes.utf8.encode(KYC_CERT_SEED), configPDA.key.toBuffer(), user.toBuffer()], this.programId);
            return {
                key: pda,
                bump: bump,
            };
        };
        this.getTokenInfoPDA = (tokenMint) => {
            const configPDA = this.getConfigPDA();
            const [pda, bump] = anchor.web3.PublicKey.findProgramAddressSync([
                anchor.utils.bytes.utf8.encode(TOKEN_INFO_SEED),
                configPDA.key.toBuffer(),
                tokenMint.toBuffer(),
            ], this.programId);
            return {
                key: pda,
                bump: bump,
            };
        };
        this.programId = programId;
        this.configId = configId;
    }
}
exports.PDA = PDA;
